"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createLinkedControllerContext = exports.createControllerContext = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var useBuilder_1 = require("./useBuilder");
var useListener_1 = require("./useListener");
var useController_1 = require("./useController");
function createControllerContext() {
    var reactContext = (0, react_1.createContext)(undefined);
    var controllerContext = {
        Provider: function () { return (0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, {}); },
        Builder: function () { return (0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, {}); },
        Listener: function () { return (0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, {}); },
        _context: reactContext,
    };
    var ControllerProvider = function (_a) {
        var create = _a.create, children = _a.children;
        var controllerRef = (0, react_1.useRef)(create());
        (0, react_1.useEffect)(function () {
            var controller = controllerRef.current;
            return function () {
                controller.dispose();
            };
        }, []);
        return (0, jsx_runtime_1.jsx)(reactContext.Provider, { value: controllerRef.current, children: children });
    };
    controllerContext.Provider = ControllerProvider;
    var Builder = function (_a) {
        var builder = _a.builder, buildWhen = _a.buildWhen;
        var _b = (0, useBuilder_1.useBuilder)(controllerContext, buildWhen), state = _b[0], controller = _b[1];
        return builder(state, controller);
    };
    controllerContext.Builder = Builder;
    var Listener = function (_a) {
        var listener = _a.listener, listenWhen = _a.listenWhen, children = _a.children;
        var controller = (0, useController_1.useController)(controllerContext);
        (0, useListener_1.useListener)(controllerContext, function (state) { return listener(state, controller); }, listenWhen);
        return (0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: children });
    };
    controllerContext.Listener = Listener;
    return controllerContext;
}
exports.createControllerContext = createControllerContext;
function createLinkedControllerContext() {
    return createControllerContext();
}
exports.createLinkedControllerContext = createLinkedControllerContext;
//# sourceMappingURL=ControllerContext.js.map