"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useListener = void 0;
var react_1 = require("react");
var useController_1 = require("./useController");
function useListener(context, listener, listenWhen) {
    if (listenWhen === void 0) { listenWhen = function () { return true; }; }
    var controller = (0, useController_1.useController)(context);
    var stateRef = (0, react_1.useRef)(controller.state);
    var callback = function (newState) { return listener(newState); };
    (0, react_1.useEffect)(function () {
        var subcription = controller.observable.subscribe(function (newState) {
            var state = stateRef.current;
            if (state === newState) {
                return;
            }
            if (listenWhen(state, newState) === true) {
                callback(newState);
            }
            stateRef.current = newState;
        });
        return function () {
            subcription.unsubscribe();
        };
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [listenWhen, listener]);
    return controller;
}
exports.useListener = useListener;
//# sourceMappingURL=useListener.js.map