import { useEffect, useRef } from 'react';
import { useController } from './useController';
function useListener(context, listener, listenWhen) {
    if (listenWhen === void 0) { listenWhen = function () { return true; }; }
    var controller = useController(context);
    var stateRef = useRef(controller.state);
    var callback = function (newState) { return listener(newState); };
    useEffect(function () {
        var subcription = controller.observable.subscribe(function (newState) {
            var state = stateRef.current;
            if (state === newState) {
                return;
            }
            if (listenWhen(state, newState) === true) {
                callback(newState);
            }
            stateRef.current = newState;
        });
        return function () {
            subcription.unsubscribe();
        };
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [listenWhen, listener]);
    return controller;
}
export { useListener };
//# sourceMappingURL=useListener.js.map